<template>
  <form class="card" v-on:submit="submit">
    <h3>{{ headerText }}</h3>
    <div v-for="field in fields">
      <label>
        {{ field.label + (field.required ? ' *' : '') }}
        <textarea v-if="field.type == 'textarea'" rows="5" cols="30" v-model="field.value">
        </textarea>
        <select v-else-if="field.type == 'dropdown'" v-model="field.value">
          <option v-for="option in field.options" :value="option.value">
            {{ option.label }}
          </option>
        </select>
        <input v-else :type="field.type" v-model="field.value">
      </label>
      <label class="error-message">
        {{ errors[field.name] }}
      </label>
    </div>
    <input type="submit" :value="buttonText">
    <div class="loading-spinner-overlay" v-if="loading"></div>
  </form>
</template>

<script>
import axios from 'axios';
import { proxy } from '../config/proxy';

export default {
  props: {
    // text at the top of the form
    headerText: String,
    // text on submit button
    buttonText: String,
    // fields have props 'name' 'label' 'type' 'value' 'required' and for dropdowns 'options'
    fields: Array,
    // rest api endpoint url
    endpointUrl: String,
    // rest api endpoint type 'get' 'post' 'delete' 'put'
    endpointType: String,
    // object holding a 'key' and 'value', if not undefined will be sent along with form data
    requestParam: Object,
  },
  data() {
    return {
      errors: {},
      loading: false,
    };
  },
  methods: {
    submit(event) {
      // prevent page reload
      event.preventDefault();
      // empty errors
      this.errors = {};
      // frontend validation, make sure required fields are filled
      for (let field of this.fields) {
        if (field.required && (
            typeof field.value === 'undefined'
        || (typeof field.value === 'string' && !field.value.trim().length)
        )) {
          this.errors[field.name] = 'This field needs to be filled';
        };
      }
      // if validation errors are found, end function
      if (Object.keys(this.errors).length) return;
      // toggle loading spinner on
      this.loading = true;
      // convert array of fields into object
      const form = this.fields.reduce((acc, field) => (
        { ...acc, [field.name]: field.value }
      ), {});
      // http request
      axios[this.endpointType](   // request type
        proxy + this.endpointUrl, // request url
        (this.requestParam        // request params
          ? { form, [this.requestParam.key]: this.requestParam.value }
          : form),
      ).then(response => {
        // toggle loading spinner off
        this.loading = false;
        // empty errors
        this.errors = {};
        // empty form
        for (let field of this.fields) field.value = undefined;
        // pass successful response to parent component
        this.$emit('success', response);
      }).catch(error => {
        // toggle loading spinner off
        this.loading = false;
        // display error messages
        this.errors = error.response.data;
      });
    },
  },
}
</script>

<style lang="scss">
textarea,
select,
input[type="date"] {
  box-sizing: border-box;
  border: 3px solid #0001;
  outline: none;
  margin: 10px 0;
}
input[type="submit"],
input[type="button"] {
  border: none;
  padding: 10px 20px;
  border-radius: 5px;
  margin: 10px 0 0;
  width: 100%;
  color: white;
  outline: none;
  transition: 0.25s;
  background: #4fd1a7;
  &:active {
    background: #33896d;
    transition: 0s;
    box-shadow: inset 0 10px 10px #0005;
  }
  &:hover {
    background: #68f2c5;
  }
  &.delete-button {
    background: #cf7171;
    &:hover {
      background: #f69191;
    }
    &:active {
      background: #773333;
    }
  }
  &.edit-button {
    background: #d3b836;
    margin-right: 10px;
    &:hover {
      background: #ebd151;
    }
    &:active {
      background: #9d871c;
    }
    &:disabled {
      background: #0002;
    }
  }
}
input[type="text"],
input[type="email"],
input[type="number"],
input[type="password"] {
  border: none;
  width: 200px;
  margin: 10px 0;
  padding: 10px 0 0;
  border-radius: 0;
  border-bottom: 2px solid #0001;
  outline: none;
}
.error-message {
  color: #ff6a6a;
  font-size: 14px;
  padding-bottom: 5px;
}
.loading-spinner-overlay {
  position: absolute;
  top: -10px;
  bottom: -10px;
  left: -10px;
  right: -10px;
  background: #abbd747d;
  z-index: 1;
  &::before {
    content: '';
    position: absolute;
    top: 50%;
    left: 50%;
    border: solid 10px;
    border-color: #4fd1a7 transparent transparent transparent;
    border-radius: 50%;
    width: 30px;
    height: 30px;
    animation: spinning linear infinite 0.25s;
  }
}
@keyframes spinning {
  from {
    transform: translate(-50%, -50%) rotate(0deg);
  }
  to {
    transform: translate(-50%, -50%) rotate(360deg);
  }
}
</style>
